#!/usr/bin/python
# -*- coding: utf_8 -*-

import pygtk
pygtk.require("2.0")

import gtk, gobject

import os, stat, string, commands, grp, pwd

devices = (
	"/dev/ttyS0",
	"/dev/ttyS1",
	"/dev/ttyS2",
	"/dev/ttyS3"
)

class BrowseEntry(gtk.HBox):
	def __init__(self):
		gtk.HBox.__init__(self)
		
		self.entry = gtk.Entry()
		self.button = gtk.Button("...")
		
		self.pack_start(self.entry)
		self.pack_start(self.button, gtk.FALSE)
		
		self.set_spacing(2)
		
		self.show_all()
		
def show_error(text, parent=None, msg_type=gtk.MESSAGE_ERROR):
	error_dialogue = gtk.MessageDialog(type=msg_type, 
		message_format=text,
		buttons=gtk.BUTTONS_OK,
		parent=parent)
	error_dialogue.label.set_selectable(gtk.FALSE)
	error_dialogue.run()
	error_dialogue.destroy()

class ppp_setup:
	
	def delete_event(self, widget, data=None):
		return gtk.FALSE
		
	def destroy(self, widget, data=None):		
		gtk.main_quit()
		
	def __init__(self):
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		
		# Заголовок окна храним в отдельной переменной - для удобства
		self.window_title = "PPP Setup"
		
		self.window.set_title(self.window_title)
		self.window.set_resizable(gtk.FALSE)
		self.window.connect("delete_event", self.delete_event)
		self.window.connect("destroy", self.destroy)		
		self.window.set_border_width(0)		
		self.window.set_position(gtk.WIN_POS_CENTER)
		
		# Переменные
		self.options = {
			"device" : "",
			"group" : "",
			"other_groups" : [],
			"create_new_group" : False,
			"allowed_users" : [],
			"chmod_device" : True,
			"chmod_etc_ppp" : True,
			"suid_pppd" : True,
			"chmod_resolv_conf" : False
		}
		
		self.grouplist = self.get_grouplist()
		self.userlist = self.get_userlist()
		######################################################
		
		vbox = gtk.VBox(gtk.FALSE, 2)
		
		widget_length = 150
		
		label = gtk.Label("PPP group:")
		label.set_justify(gtk.JUSTIFY_LEFT)
		label.set_alignment(0, 0.5)		
		#group = gtk.Entry()
		#group.set_size_request(widget_length, -1)
		#group.set_text("network")
		# !!!
		self.group = gtk.Combo()
		self.group.entry.set_editable(gtk.FALSE)
		self.group.set_popdown_strings(self.grouplist)
		new_group = gtk.Button("_New...")
		new_group.connect("clicked", self.onNewGroup)
		hbox_group = gtk.HBox(gtk.FALSE, 2)
		hbox_group.pack_start(self.group)
		hbox_group.pack_start(new_group, gtk.FALSE)
		hbox_group.set_size_request(widget_length, -1)
		
		hbox = gtk.HBox(gtk.FALSE, 2)
		hbox.pack_start(label)
		hbox.pack_start(hbox_group, gtk.FALSE)
		
			
		
		label = gtk.Label("Modem device:")
		label.set_justify(gtk.JUSTIFY_LEFT)
		label.set_alignment(0, 0.5)		
		self.device = gtk.Combo()
		self.device.entry.set_editable(gtk.FALSE)
		self.device.set_popdown_strings(devices)
		self.device.set_size_request(widget_length, -1)
		
		hbox2 = gtk.HBox(gtk.FALSE, 2)
		hbox2.pack_start(label)
		hbox2.pack_start(self.device, gtk.FALSE)
		
		
		label = gtk.Label("PPP user(s):")
		label.set_justify(gtk.JUSTIFY_LEFT)
		label.set_alignment(0, 0.5)		
		self.users = gtk.Entry()
		self.users.set_editable(gtk.FALSE)
		
		self.get_allowed_users_from_file()
		self.users.set_text(string.join(self.options["allowed_users"], ","))
		
		browse = gtk.Button("...")
		browse.connect("clicked", self.onBrowseUsers)
		hbox_user = gtk.HBox(gtk.FALSE, 2)
		hbox_user.pack_start(self.users)
		hbox_user.pack_start(browse, gtk.FALSE)
		hbox_user.set_size_request(widget_length, -1)	
		
		#user = BrowseEntry()
		#user.set_size_request(widget_length, -1)
		#user.entry.set_text(self.get_network_users())

		hbox3 = gtk.HBox(gtk.FALSE, 2)
		hbox3.pack_start(label)
		hbox3.pack_start(hbox_user, gtk.FALSE)
		
		
		label = gtk.Label("Additional groups:")
		label.set_justify(gtk.JUSTIFY_LEFT)
		label.set_alignment(0, 0.5)		
		self.other_gr = gtk.Entry()
		self.other_gr.set_editable(gtk.FALSE)
		
		#self.get_allowed_users_from_file()
		#self.users.set_text(string.join(self.options["allowed_users"], ","))
		
		browse = gtk.Button("...")
		browse.connect("clicked", self.onBrowseGroups)
		hbox_othgr = gtk.HBox(gtk.FALSE, 2)
		hbox_othgr.pack_start(self.other_gr)
		hbox_othgr.pack_start(browse, gtk.FALSE)
		hbox_othgr.set_size_request(widget_length, -1)	
		
		hbox4 = gtk.HBox(gtk.FALSE, 2)
		hbox4.pack_start(label)
		hbox4.pack_start(hbox_othgr, gtk.FALSE)
						
		self.device_perms = gtk.CheckButton("Change device's ownership")
		self.etc_ppp_perms = gtk.CheckButton("Change ownership of /etc/ppp/*")
		self.suid_pppd = gtk.CheckButton("Let PPPD run with root privileges")
		self.resolv_conf_perms = gtk.CheckButton("Change ownership of /etc/resolv.conf")
		
		vbox1 = gtk.VBox(gtk.FALSE, 2)
		vbox1.set_border_width(2)
		
		frame = gtk.Frame("Options")
		vbox1.pack_start(self.device_perms)
		vbox1.pack_start(self.etc_ppp_perms)
		vbox1.pack_start(self.suid_pppd)
		vbox1.pack_start(self.resolv_conf_perms)
		frame.add(vbox1)		
		
		proceed = gtk.Button("_Create script...")		#stock=gtk.STOCK_APPLY)
		proceed.connect("clicked", self.onProceed)
		
		#cancel = gtk.Button(stock=gtk.STOCK_CANCEL)
		#cancel.connect("clicked", self.destroy)

		bbox = gtk.HButtonBox()
		bbox.set_spacing(2)
		bbox.set_layout(gtk.BUTTONBOX_END)
		bbox.pack_end(proceed)
		#bbox.pack_end(cancel)
		
		vbox.pack_start(hbox)
		vbox.pack_start(hbox2)
		vbox.pack_start(hbox3)
		vbox.pack_start(hbox4)
		vbox.pack_start(frame)
		vbox.pack_start(bbox)
		vbox.show_all()
		
		self.window.add(vbox)
		self.window.show()
		
	def onProceed(self, widget, data=None):		
		self.options["device"] = self.device.entry.get_text()
		self.options["group"] = self.group.entry.get_text()
		self.options["chmod_device"] = self.device_perms.get_active()
		self.options["chmod_etc_ppp"] = self.etc_ppp_perms.get_active()
		self.options["suid_pppd"] = self.suid_pppd.get_active()
		self.options["chmod_resolv_conf"] = self.resolv_conf_perms.get_active()
		
		action_num = 0
		
		script = "#!/bin/sh\n#Script generated by gDial\n\n"
		
		if self.options["create_new_group"] == True:
			action_num += 1
			script += "#Creating PPP group\n"
			script += "groupadd %s\n" % self.options["group"]
			script += "\n"
				
		script += "#Adding users to the PPP group (and perhaps some others)\n"
		for u in self.options["allowed_users"]:
			user_groups = self.get_user_groups(u)
			# Если пользователь еще не записан в группу PPP...
			if self.options["group"] not in user_groups:
				action_num += 1
				if len(self.options["other_groups"]) == 0:
					script += "usermod -G %s,%s %s\n" % (self.options["group"], string.join(user_groups, ","), u)
				else:
					script += "usermod -G %s,%s,%s %s\n" % (self.options["group"], string.join(user_groups, ","), string.join(self.options["other_groups"], ","), u)
		script += "\n"
			
		if self.options["chmod_device"] == True:
			action_num += 1
			script += "#Changing device ownership\n"
			script += "chmod g+rw %s\n" % self.options["device"]
			script += "chgrp %s %s\n" % (self.options["group"], self.options["device"])
			script += "\n"
			
		if self.options["chmod_etc_ppp"] == True:
			action_num += 1
			script += "#Changing /etc/ppp/* ownership\n"
			script += "chmod g+rw /etc/ppp/*\n"
			script += "chgrp %s /etc/ppp/\n" % self.options["group"]
			script += "\n"
			
		if self.options["suid_pppd"] == True:
			action_num += 1
			script += "#Let's run PPPD with root privileges\n"
			script += "chmod u+s /usr/sbin/pppd\n"
			script += "\n"
			
		if self.options["chmod_resolv_conf"] == True:
			action_num += 1
			script += "#Changing /etc/resolv.conf ownership\n"
			script += "chmod g+rw /etc/resolv.conf\n"
			script += "chgrp %s /etc/resolv.conf\n" % self.options["group"]
			
		if action_num == 0:
			show_error("No actions required. Script generation cancelled.", self.window, msg_type=gtk.MESSAGE_WARNING)
			return
			
		dlg = gtk.MessageDialog(type=gtk.MESSAGE_INFO, 
			message_format="The script is ready. It will be saved as\n%s,\nand needs the root privileges for running.\nClick OK to save the script and quit,\nor Cancel to abort:" % os.path.expanduser("~/ppp_setup.sh"), 
			buttons=gtk.BUTTONS_OK_CANCEL,
			parent=self.window)
			
		dlg.set_has_separator(gtk.FALSE)
		dlg.set_default_response(gtk.RESPONSE_OK)
	
		scrolled = gtk.ScrolledWindow()
		scrolled.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
		scrolled.set_shadow_type(gtk.SHADOW_IN)
		scrolled.set_size_request(450, 150)
		
		textview = gtk.TextView()
		textview.set_editable(gtk.FALSE)
		textview.set_cursor_visible(gtk.FALSE)
		
		textbuffer = textview.get_buffer()
		textbuffer.set_text(script)
		
		scrolled.add(textview)
		
		scrolled.show()
		textview.show()
				
		dlg.vbox.pack_start(scrolled)
		
		if dlg.run() == gtk.RESPONSE_OK:
			f = open(os.path.expanduser("~/ppp_setup.sh"), "w+")
			f.write(script)
			if f.close() != None:
				show_error("File handling error!")
			else:
				os.chmod(os.path.expanduser("~/ppp_setup.sh"), stat.S_IRUSR|stat.S_IWUSR|stat.S_IXUSR)
				gtk.main_quit()
		dlg.destroy()	
			
	def onBrowseUsers(self, widget, data=None):
		dlg = gtk.Dialog("Manage Users", self.window, 
			gtk.DIALOG_MODAL|gtk.DIALOG_DESTROY_WITH_PARENT, 
			(gtk.STOCK_OK, gtk.RESPONSE_OK, 
			gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
		dlg.set_has_separator(gtk.FALSE)
		dlg.set_resizable(gtk.FALSE)
		dlg.set_default_response(gtk.RESPONSE_OK)
		
		self.model = gtk.ListStore(gobject.TYPE_BOOLEAN, gobject.TYPE_STRING)
		self.view = gtk.TreeView(self.model)
		rendererToggle = gtk.CellRendererToggle()
		rendererText = gtk.CellRendererText()
		#selection = self.view.get_selection()
		rendererToggle.connect("toggled", self.on_sel_toggled)
			
		column = gtk.TreeViewColumn("", rendererToggle, active=0)
		self.view.append_column(column)
		
		column2 = gtk.TreeViewColumn("User name", rendererText, text=1)
		self.view.append_column(column2)
			
		scrolled = gtk.ScrolledWindow()
		scrolled.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
		scrolled.set_shadow_type(gtk.SHADOW_IN)
		scrolled.add(self.view)
		
		scrolled.set_size_request(200, 200)
		
		# Добавляем...
		self.fill_user_list()

		dlg.vbox.pack_start(scrolled)
		dlg.vbox.show_all()
		
		if dlg.run() == gtk.RESPONSE_OK:
			self.options["allowed_users"] = []
			self.model.foreach(self.tree_enumerator)
			self.users.set_text(string.join(self.options["allowed_users"], ","))
			
		dlg.destroy()
		
	def onBrowseGroups(self, widget, data=None):
		dlg = gtk.Dialog("Manage Groups", self.window, 
			gtk.DIALOG_MODAL|gtk.DIALOG_DESTROY_WITH_PARENT, 
			(gtk.STOCK_OK, gtk.RESPONSE_OK, 
			gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
		dlg.set_has_separator(gtk.FALSE)
		dlg.set_resizable(gtk.FALSE)
		dlg.set_default_response(gtk.RESPONSE_OK)
		
		self.model1 = gtk.ListStore(gobject.TYPE_BOOLEAN, gobject.TYPE_STRING)
		self.view1 = gtk.TreeView(self.model1)
		rendererToggle = gtk.CellRendererToggle()
		rendererText = gtk.CellRendererText()
		#selection = self.view.get_selection()
		rendererToggle.connect("toggled", self.on_sel_toggled1)
			
		column = gtk.TreeViewColumn("", rendererToggle, active=0)
		self.view1.append_column(column)
		
		column2 = gtk.TreeViewColumn("Group name", rendererText, text=1)
		self.view1.append_column(column2)
			
		scrolled = gtk.ScrolledWindow()
		scrolled.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
		scrolled.set_shadow_type(gtk.SHADOW_IN)
		scrolled.add(self.view1)
		
		scrolled.set_size_request(200, 200)
		
		# Добавляем...
		self.fill_group_list()
		# !!!

		dlg.vbox.pack_start(scrolled)
		dlg.vbox.show_all()
		
		if dlg.run() == gtk.RESPONSE_OK:
			pass
			self.options["other_groups"] = []
			self.model1.foreach(self.tree_enumerator1)
			self.other_gr.set_text(string.join(self.options["other_groups"], ","))
			
		dlg.destroy()
		
	def onNewGroup(self, widget, data=None):
		dlg = gtk.Dialog("New Group", self.window, 
			gtk.DIALOG_MODAL|gtk.DIALOG_DESTROY_WITH_PARENT, 
			(gtk.STOCK_OK, gtk.RESPONSE_OK, 
			gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
		dlg.set_has_separator(gtk.FALSE)
		dlg.set_resizable(gtk.FALSE)
		dlg.set_default_response(gtk.RESPONSE_OK)
		
		label = gtk.Label("Enter the new group's name:")
		dlg.newname = gtk.Entry()
		
		dlg.vbox.pack_start(label)
		dlg.vbox.pack_start(dlg.newname)
		
		dlg.vbox.show_all()
		
		if dlg.run() == gtk.RESPONSE_OK:
			self.options["create_new_group"] = True
			new_group = dlg.newname.get_text()
			if new_group in self.grouplist:
				show_error("Group '%s' already exists!" % new_group)
			else:
				self.grouplist.append(new_group)
				self.group.set_popdown_strings(self.grouplist)
				self.group.list.select_item(len(self.grouplist)-1)
			
		dlg.destroy()
		
	def tree_enumerator(self, model, path, iter, user_data=None):
		state = model.get_value(iter, 0)
		name = model.get_value(iter, 1)
		
		if state == True:
			self.options["allowed_users"].append(name)
			
	def tree_enumerator1(self, model, path, iter, user_data=None):
		state = model.get_value(iter, 0)
		name = model.get_value(iter, 1)
		
		if state == True:
			self.options["other_groups"].append(name)
		
	def fill_user_list(self):
		self.model.clear()
		
		for user in self.userlist:
			iter = self.model.append()
			
			self.model.set_value(iter, 0, user in self.options["allowed_users"])
			self.model.set_value(iter, 1, user)
			
	def fill_group_list(self):
		
		self.model1.clear()
		
		for group in self.get_grouplist():
			iter = self.model1.append()
			
			self.model1.set_value(iter, 0, group in self.options["other_groups"])
			self.model1.set_value(iter, 1, group)
		
	def on_sel_toggled(self, widget, data=None):
		model, iter = self.view.get_selection().get_selected()
		if iter != None:
			self.model.set_value(iter, 0, not self.model.get_value(iter, 0))
			
	def on_sel_toggled1(self, widget, data=None):
		model, iter = self.view1.get_selection().get_selected()
		if iter != None:
			self.model1.set_value(iter, 0, not self.model1.get_value(iter, 0))
		
	def get_allowed_users_from_file(self):
		self.options["allowed_users"] = []
		
		(status, output) = commands.getstatusoutput("grep network /etc/group")
		if status != 0:
			print "Couldn't read /etc/group. Error follows: %s" % output
			return
			
		lines = string.split(output, "\n")
		
		for i in lines:
			user = i[string.rfind(i, ":") + 1:]
			self.options["allowed_users"].append(user)
	
	def get_userlist(self):
		userlist = []
		
		for u in pwd.getpwall():
			userlist.append(u[0])
		
		return userlist
		
	def get_grouplist(self):
		grouplist = []
		
		for g in grp.getgrall():
			grouplist.append(g[0])
			
		return grouplist
		
	def get_user_groups(self, user):
		groups = []
		
		gid = pwd.getpwnam(user)[3]
		try:
			group = grp.getgrgid(gid)
		except KeyError, strerror:
			print "get_user_groups() error: %s" % strerror
		else:
			groups.append(group[0])
		
		for g in grp.getgrall():
			if user in g[3] and g[0] not in groups:
				groups.append(g[0])
				
		return groups
			
	def main(self):
		gtk.main()

# End of class definition  #################################################

if __name__ == "__main__":
	ppp_setup = ppp_setup()
	ppp_setup.main()
		
